1 REM
2 REM  REAL TIME CLOCK DEMO
3 REM  THE OPTIONAL RTC HAS 8 REGISTERS WHICH ARE AS FOLLOWS:

3 REM  REGISTER			RANGE

3 REM  HUNDREDTHS OF SECS 	00-99
3 REM  SECONDS			00-59
3 REM  MINUTES			00-59
3 REM  HOURS			00-23
3 REM  DAY OF WEEK		00-07
3 REM  DAY OF MONTH		01-31
3 REM  MONTH			01-12
3 REM  YEAR			00-99
 
3 REM  THE RTC IS ACCESSED AS DEVICE #3.  THERE IS AN INTERNAL POINTER
3 REM  WHICH POINTS TO THE NEXT CLOCK REGISTER TO BE READ OR WRITTEN.
3 REM  THE COMMNAND "? #3,CHR$($C0);" MOVES THE POINTER TO HUNDREDTHS OF SECS. 
3 REM  SUBSEQUENT CHARACTERS READ OR WRITTEN WILL ACCESS THE CURRENT REGISTER 
3 REM  AND INCREMENT THE POINTER.  WHEN ALL REGISTERS ARE WRITTEN TO THE RTC.
3 REM  THE COMMAND "? #3,CHR$($E0);" WILL WRITE THESE REGISTERS TO
3 REM  THE RTC.  

3 REM   NOTE:   REMEMBER TO ALWAYS END THE CHR$(<var>) WITH A SEMICOLON SO 
3 REM   THAT THE CARRIAGE RETURN, LINEFEED WILL BE SUPRESSED, OTHERWISE THE
3 REM   VALUES 13 AND 10 (THE DECIMAL VALUES OF THESE CHARACTERS) WILL BE 
3 REM   WRITTEN TO THE RTC REGISTERS!!!

3 REM  READING THE RTC IS DONE SIMILARLY BY EXECUTING THE COMMAND 
3 REM  "? #3,CHR$($C0);" WHICH MOVES THE POINTER TO HUNDREDTHS OF SECS AND 
3 REM  REFRESHES THE RTC REGISTERS WITH THE CURRENT TIME.  THE NEXT 8 
3 REM  "INBYTE #3,<var>"  COMMANDS WILL READ THE RTC REGISTERS.
3 REM 

4 REM  THIS PROGRAM  SETS THE TIME AND DATE TO 23:59:58.00  12/31/99
5 REM  AND THEN CONTINUES TO SHOW THE TIME AS IT CHANGES.
 

6 DIM RC(7)
10 ? #3,CHR$($C0); : REM RESET CLOCK POINTER TO HUNDREDTHS OF SECONDS
20 FOR X=0 TO 7 : REM  SET THE CLOCK TO   23:59:58.00  12/31/99
30 READ DD
40 ? #3,CHR$(DD);
50 NEXT X
60 ? #3,CHR$($E0); : REM WRITE THE INTERNAL REGISTERS TO THE RTC.

70 REM SHOW "TIME  DATE"
80 GOSUB 2000: ?"  ";: GOSUB 3000:? "      ";CHR$(13);
90 GOTO 80

95 REM  |HND|SEC|MIN|HR|DAY|DAY_M|MTH|YR|
100 DATA 0,  58,  59,23,  7,   31, 12,99  

2000 REM
2010 REM  SHOW TIME IN FORMAT HH:MM:SS
2020 REM 
2030 GOSUB 3300 : REM LOAD RTC() ARRAY
2040 FOR X=3 TO 1 STEP -1
2050 ? RC(X);" ";
2060 IF X=1 THEN 2080
2070 ? ":";
2080 NEXT X
2090 RETURN



3000 REM
3010 REM  SHOW DATE IN FORMAT MM/DD/YY
3020 REM 
3030 GOSUB 3300 : REM LOAD RTC() ARRAY
3040 ? RC(6);"/";RC(5);"/";RC(7);
3050 RETURN


3300 REM
3301 REM LOAD ARRAY RTC() WITH VALUES FROM CLOCK
3302 REM
3330 ? #3,CHR$($C0);   :REM  LOAD REGISTERS AND RESET POINTER
3340 FOR X=0 TO 7
3350 INBYTE #3,RC(X)  :REM LOAD ARRAY
3360 NEXT X
3370 RETURN



