/*
 * Very simple BLACKJACK (21) game
 */

/* NOTE: If MICRO-C directory is not '\MC', change #include filename below */
#include \MC\6811io.h

#define	DECK	52
#define	SUITES	4

main()
{
	int deck[DECK], i, j, t, ace11, player_total, dealer_total, next_card;

for (;;)
{
	player_total = dealer_total = next_card = 0;

	/* Deal a deck of cards */
	for(i=0; i < DECK; ++i)
		deck[i] = i;
	for(i=0; i < DECK; ++i) {
		t = deck[i];
		deck[i] = deck[j = rand(DECK)];
		deck[j] = t; }

	/* Accept player cards */
	ace11=0;
	printf("\n");
	for(;;) 
		{
		if(player_total > 21) 
			{
			if (ace11) 
				{
				player_total -= 10;
				ace11=0; 
				}
			else 
				{
				printf("Player: %-4u", player_total);
				putstr("You BUST!\n");
				goto skip; 
				}
			}
		
		printf("Player: %-4u", player_total);
		if(get_input("Another card (Y/N)", "YN") == 'N')
			if (player_total==0)
				goto done;
			else
				break;
		
		show_card(i = deck[next_card++]);
		if(!(i %= (DECK/SUITES))) 
			{
			if (player_total < 11)
				{  
				ace11=1;
				player_total+=11; 
				}
			else
				player_total+=1;
			}
		else 
			player_total += (i > 9) ? 10 : i+1; 
		}
		
	/* Play dealer */
	printf("\n");
	ace11=0;
	for(;;) 
		{
		if(dealer_total > 21) 
			{
			if (ace11) 
				{
				dealer_total -= 10;
				ace11=0; 
				}
			else 
				{
				printf("Dealer: %-4u", dealer_total);
				putstr("You WIN!\n");
				break; 
				}
			}
		printf("Dealer: %-4u", dealer_total);
		if((dealer_total >= player_total) && (dealer_total > 16)) 
			{
			putstr("Dealer wins!\n");
			break; 
			}
		
		if((dealer_total > 16) && (dealer_total < player_total)) 
			{
			putstr("You WIN!\n");
			break; 
			}
		
		show_card(i = deck[next_card++]);
		if(!(i %= (DECK/SUITES))) 
			{
			if (dealer_total < 11) 
				{
				ace11=1;
				dealer_total+=11; 
				}
			else
				dealer_total+=1;
			}
		else 
			dealer_total += (i > 9) ? 10 : i+1; 
		}
	skip:
	}
	done:

}

/*
 * Get input character with prompt, and validate
 */
get_input(prompt, allowed)
	char prompt[], allowed[];
{
	int i;
	char buffer[50], *ptr, c;

	for(;;) {
		printf("%s?", prompt);
		getstr(ptr = buffer, sizeof(buffer)-1);
		while(isspace(c = toupper(*ptr)))
			++ptr;
		for(i = 0; allowed[i]; ++i)
			if(c == allowed[i])
				return c;
		printf("Huh?\n"); }
}

/*
 * Display a card
 */
show_card(card)
	int card;
{
	static char *suites[] = { "Hearts", "Diamonds", "Clubs", "Spades" };
	static char *cards[] = { "Ace", "Two", "Three", "Four", "Five", "Six",
		"Seven", "Eight", "Nine", "Ten", "Jack", "Queen", "King" };

	printf("%s of %s\n", cards[card % (DECK/SUITES)], suites[card / (DECK/SUITES)]);
}
//08277
