*
* DDS MICRO-C Serial I/O functions for the 68HC11
*
* Input functions
*
* Test for character from console - Translate returns
chkch	LDAA	?REGS+$2E	Get SCI status
	ANDA	#%00100000	RX ready?
	BNE	?1		Yes, handle it
	CLRB			Zero LOW
	RTS
* Read character from console - Translate Returns
getch	LDAA	?REGS+$2E	Get SCI status
	BITA	#%00100000	RX ready?
	BEQ	getch		No, wait for it
?1	LDAB	?REGS+$2F	Read the character
	CLRA			Zero HIGH
	CMPB	#$0D		Return?
	BNE	?3		Its OK
	LDAB	#$0A		Convert to newline
	RTS
* Test for character from console - Raw format
chkchr	LDAA	?REGS+$2E	Get SCI status
	ANDA	#%00100000	RX ready?
	BNE	?2		Yes, handle it
	LDD	#-1		Get -1
	RTS
* Read character from console - Raw format
getchr	LDAA	?REGS+$2E	Get SCI status
	BITA	#%00100000	RX ready?
	BEQ	getchr		No, wait for it
?2	LDAB	?REGS+$2F	Read the character
	CLRA			Zero high
?3	RTS
* Read a string (with editing) from the console: getstr(buffer, length)
getstr	TSX			Address stack
	LDY	4,X		Get buffer ptr
	LDX	#0		Starting length is zero
?4	BSR	getch		Get a character
	CMPB	#$7F		Delete?
	BEQ	?5		Yes, handle it
	CMPB	#$08		Backspace?
	BEQ	?5		Yes, handle it
	CMPB	#$0A		Enter?
	BEQ	?6		Yes, handle it
	PSHY			Save buffer ptr
	TSY			Address stack
	CPX	4,Y		Are we within length
	PULY			Restore buffer ptr
	BHS	?4		No, ignore
	STAB	,Y		Write to buffer
	INX			Advance length
	INY			Advance buffer ptr
	BSR	?putchr		Echo character to console
	BRA	?4		And proceed
?5	CPX	#0		Any data in buffer?
	BEQ	?4		No, ignore
	LDAB	#$08		Backspace
	BSR	?putchr		Echo
	LDAB	#' '		Overwrite with space
	BSR	?putchr		Echo
	LDAB	#$08		Backspace
	BSR	?putchr		Echo
	DEX			Reduce length
	DEY			Reduce buffer ptr
	BRA	?4		And proceed
?6	CLR	,Y		Zero end of buffer
	BSR	?putch		New line on console
	XGDX			Return buffer length
	RTS
*
* Output functions
*
* Write a string to the serial port: putstr(char *s)
putstr	TSX			Point to parms
	LDX	2,X		Get pointer
* Write string(X) to serial port
?putstr	LDAB	,X		Get char
	BEQ	?3		End of line, exit
	INX			Advance pointer
	BSR	?putch		Write char to serial port
	BRA	?putstr		And proceed
* Write character to serial port port with newline translation
putch	TSX			Point to stack
	LDD	2,X		Get character value
* Write character(B) to serial port with newline translation
?putch	CMPB	#$0A		Newline?
	BNE	?putchr		No, standard char
	BSR	?putchr		Write LF
	LDAB	#$0D		Get CR
	BRA	?putchr		Write character
* Write character to serial port in RAW form: putchr(char c)
putchr	TSX			Point to stack
	LDD	2,X		Read character
* Write character(B) to serial port in RAW form
?putchr	LDAA	?REGS+$2E	Get SCI status
	BITA	#%10000000	Ok to transmit?
	BEQ	?putchr		No, do not write
	STAB	?REGS+$2F	Write character to Data register
	RTS
*08394
